#include <math.h>
#include <stdio.h>


#define N 1024
// define the number of points

unsigned int no_of_add_bits;
unsigned int no_of_shifts;

unsigned int mod[N/2];
unsigned int pm rev_mod[N/2];

unsigned int pointer;
unsigned int rev_pointer;

unsigned int modifer;
unsigned int index;

unsigned int old_pointer;
unsigned int old_rev_pointer;

unsigned int new_mod;
unsigned int new_rev_mod;

FILE *mod_file;
FILE *rev_mod_file;

void main ()
{
	no_of_add_bits = log(N)/log(2);
	no_of_shifts = 32 - no_of_add_bits;

	mod_file = fopen("mod.dat","w");
  	rev_mod_file = fopen("rev_mod.dat","w");
   
	index = 0;
	old_pointer = 0;
	old_rev_pointer = 0;
		
	for (pointer =0; pointer<N; pointer++)
	{
		
		
		asm(" r0 = dm(_pointer);");
		asm(" i4 = r0;");
		asm(" bitrev(i4,0);");
		asm(" r0 = i4;");
		asm(" dm(_rev_pointer) = r0;");
		rev_pointer >>= no_of_shifts;
		
		if (pointer<rev_pointer)
		{
			mod[index] = pointer - old_pointer;
			fprintf(mod_file,"%d\n",mod[index]);
			
			rev_mod[index] = rev_pointer - old_rev_pointer;
			fprintf(rev_mod_file,"%d\n",rev_mod[index]);
			
			old_pointer = pointer;
			old_rev_pointer = rev_pointer;
			index += 1;
		}
			
	}
	
	// store the mod and rev_mod arrays in to files
	fclose(mod_file);
  	fclose(rev_mod_file);

	
	printf("\n the size fo the look up table is %d",index);
}
